(function ($) {
    "use strict";

    // Initiate the wowjs
    new WOW().init();


    // Spinner
    var spinner = function () {
        setTimeout(function () {
            if ($('#spinner').length > 0) {
                $('#spinner').removeClass('show');
            }
        }, 1);
    };
    spinner();


    // Sticky Navbar
    $(window).scroll(function () {
        if ($(this).scrollTop() > 300) {
            $('.sticky-top').addClass('shadow-sm').css('top', '0px');
        } else {
            $('.sticky-top').removeClass('shadow-sm').css('top', '-100px');
        }
    });
    
    
    // Back to top button
    $(window).scroll(function () {
        if ($(this).scrollTop() > 300) {
            $('.back-to-top').fadeIn('slow');
        } else {
            $('.back-to-top').fadeOut('slow');
        }
    });
    $('.back-to-top').click(function () {
        $('html, body').animate({scrollTop: 0}, 1500, 'easeInOutExpo');
        return false;
    });


    // Header carousel
    $(".header-carousel").owlCarousel({
        autoplay: true,
        smartSpeed: 1500,
        items: 1,
        dots: true,
        loop: true,
        nav : true,
        navText : [
            '<i class="bi bi-chevron-left"></i>',
            '<i class="bi bi-chevron-right"></i>'
        ]
    });


    // Testimonials carousel
    $(".testimonial-carousel").owlCarousel({
        autoplay: true,
        smartSpeed: 1000,
        margin: 24,
        dots: false,
        loop: true,
        nav : true,
        navText : [
            '<i class="bi bi-arrow-left"></i>',
            '<i class="bi bi-arrow-right"></i>'
        ],
        responsive: {
            0:{
                items:1
            },
            992:{
                items:2
            }
        }
    });

    
    //Cross-Site Request Forgery (CSRF) Protection
    const helmet = require('helmet');
    const app = express();

     // Enable CSP with specific directives
    app.use(
       helmet.contentSecurityPolicy({
        directives: {
            defaultSrc: ["'self'"],
            scriptSrc: ["'self'", 'trusted-scripts.com'],
            // Add other directives as needed
        },
    })
    ); 
    
})(jQuery);
////////////////////////////////////////////////
// const express = require('express');
// const passport = require('passport');
// const LocalStrategy = require('passport-local').Strategy;
// const bcrypt = require('bcrypt');
// const session = require('express-session');

// const app = express();
// const port = 3000;

// // Configure session middleware
// app.use(session({ secret: 'your-secret-key', resave: false, saveUninitialized: false }));

// // Initialize Passport
// app.use(passport.initialize());
// app.use(passport.session());

// // Example user data (you should use a real database)
// const users = [
//   { id: 1, username: 'user1', password: '$2b$10$1FUb0n7D2tRQW4mB4GH4t.yfPm8N1nuBMnXlpkcjgU/1fWn4BJs6i' }, // Password: "password1"
//   { id: 2, username: 'user2', password: '$2b$10$8sdB6FPrP0uglLoPeOPHg.ySW.RJ5CbvL6OC5x5jIZDR5AtQlVQoG' }, // Password: "password2"
// ];

// // Configure Passport to use a LocalStrategy for username and password authentication
//     passport.use(new LocalStrategy((username, password, done) => {
//     const user = users.find((user) => user.username === username);
//   if (!user) {
//     return done(null, false, { message: 'User not found' });
//   }

//   // Verify the password using bcrypt
//   bcrypt.compare(password, user.password, (err, isMatch) => {
//     if (err) {
//       return done(err);
//     }
//     if (!isMatch) {
//       return done(null, false, { message: 'Incorrect password' });
//     }

//     return done(null, user);
//   });
// }));

// // Serialize user information to the session
// passport.serializeUser((user, done) => {
//   done(null, user.id);
// });

// // Deserialize user from the session
// passport.deserializeUser((id, done) => {
//   const user = users.find((user) => user.id === id);
//   done(null, user);
// });

// // Routes
// app.get('/', (req, res) => {
//   res.send('Welcome to the secure authentication example.');
// });

// app.get('/login', (req, res) => {
//   res.send('Login page');
// });

// // Authentication route
// app.post('/login', passport.authenticate('local', {
//   successRedirect: '/dashboard',
//   failureRedirect: '/login',
//   failureFlash: true,
// }));

// app.get('/dashboard', (req, res) => {
//   if (req.isAuthenticated()) {
//     res.send('Dashboard');
//   } else {
//     res.redirect('/login');
//   }
// });

// app.listen(port, () => {
//   console.log(`Server is running on http://localhost:${port}`);
// });

// Connect to MongoDB and perform a parameterized query
// MongoClient.connect(url, { useNewUrlParser: true }, function(err, client) {
//     if (err) throw err;
  
//     const db = client.db(dbName);
//     const collection = db.collection('documents');
  
//     // User input
//     const userInput = safeUserInput(req.body.input); // Be sure to validate and sanitize user input
  
//     // Using parameterized query to find documents
//     collection.find({ field: userInput }).toArray(function(err, docs) {
//       if (err) throw err;
  
//       // Process the query results
//       console.log(docs);
  
//       // Close the connection
//       client.close();
//     });
//   });
const express = require('express');
const bodyParser = require('body-parser');
const mongoose = require('mongoose');
const User = require('./models/user'); // Define your user model

const app = express();
const port = 3000;

app.use(bodyParser.json());

// Connect to your MongoDB database
mongoose.connect('mongodb://localhost/yourdatabase', {
  useNewUrlParser: true,
  useUnifiedTopology: true,
});

// Handle user registration
app.post('/register', async (req, res) => {
  try {
    const { username, password } = req.body;

    // Input validation
    if (!username || !password) {
      return res.status(400).json({ message: 'Username and password are required.' });
    }

    // Create a new user
    const user = new User({ username, password });

    // Save the user to the database
    await user.save();

    res.status(200).json({ message: 'User registered successfully' });
  } catch (error) {
    res.status(500).json({ message: 'Error registering user' });
  }
});

app.listen(port, () => {
  console.log(`Server is running on port ${port}`);
});